
class AltiusConfigurationKey:

    def __init__(self, channel: str = None, *, datestr: str = None, wavelength: float = None):

        assert (channel is not None)
        self._channel = channel.lower()
        self._datestr = datestr
        self._wavelen = wavelength

    @property
    def channel(self) -> str:
        """
        The Altius channel: uv, vis or nir
        """
        return self._channel

    @property
    def datestr(self) -> str:
        """
        The configuration date. Typically used for PSF selection, e.g. '2020-10-20'
        """
        return self._datestr

    @property
    def wavelength(self) -> float:
        """
        The PSF wavelength selection. e.g. 550.0
        """
        return self._wavelen
