from .load_specs import load_specs


# ------------------------------------------------------------------------------
#           Class DetectorSpecs
# ------------------------------------------------------------------------------
class OrbitParams_SimpleOrbit:
    """
    A simple class with a list of attributes taken form the yaml file
    """

    def __init__(self):

        specs = load_specs('simple_orbit_params.yaml')
        self._nominal_spacecraft_altitude = specs['nominal_spacecraft_altitude_km']
        self._local_time_ascending_node = specs['local_time_ascending_node']
        self._boresight_tangent_altitude = specs['boresight_tangent_altitude']

    @property
    def nominal_spacecraft_altitude(self) -> float:
        """The nominal altitude of the satellite in meters"""
        return self._nominal_spacecraft_altitude

    @property
    def boresight_tangent_altitude(self) -> float:
        """The tangent altitude in meters of the boresight in bright limb mode"""
        return self._boresight_tangent_altitude

    @property
    def local_time_ascending_node(self) -> float:
        """The local time in hours (0.0 to 24.0) of the ascending node."""
        return self._local_time_ascending_node
    # ------------------------------------------------------------------------------
    #           get_arcminutes_per_km_in_limb
    # ------------------------------------------------------------------------------

    # def get_radians_per_km_in_limb(self, radiansperpixel) -> float:
    #     """
    #     Returns the number of radians that represent one kilometer in the limb. This is an
    #     approximate number but allows for a quick and easy altitude mapping if we know how many
    #     radians each pixel represents.
    #     """
    #     Re = 6371000.0
    #     Hl = Re
    #     Hsc = self._nominal_spacecraft_altitude + Re
    #     fov = self.fov_angular_size
    #     halfangle = (fov[1, 0] - fov[0, 0]) / 2.0                       # get the half angle of the detector in the vertical direction
    #     theta1 = math.asin(Hl / Hsc)                                    # Get the angle to 0 km limb altitude
    #     theta2 = theta1 + halfangle                                     # get an offset of half the vertical field of view
    #     H2 = Hsc * math.sin(theta2)                                       # Get the height of this pointy
    #     radsperkm = halfangle / (H2 - Hl)                                 # get the nominal radians per km across the useful field of view.
    #     return radsperkm                                                # and we have nominal radians per km in limb
